package ru.dbotthepony.mc.otm.container

import net.minecraft.world.Container
import net.minecraft.world.item.ItemStack

class ContainerIterator(private val container: Container) : MutableIterator<ItemStack> {
	private var index = 0

	override fun hasNext(): Boolean {
		return index < container.containerSize
	}

	override fun next(): ItemStack {
		if (index >= container.containerSize) {
			throw IllegalStateException("Already finished iterating")
		}

		return container[index++]
	}

	override fun remove() {
		if (index == 0) {
			throw IllegalStateException("Never called next()")
		}

		container[index - 1] = ItemStack.EMPTY
	}
}

fun Container.iterator() = ContainerIterator(this)
