package ru.dbotthepony.mc.otm.core

import net.minecraft.world.item.ItemStack

open class NonEmptyItemStackIterator(protected open val parent: Iterator<ItemStack>) : Iterator<ItemStack> {
	private var itemStack: ItemStack? = null
	private var searched = false

	private fun search() {
		searched = true

		if (itemStack != null) {
			return
		}

		for (stack in parent) {
			if (!stack.isEmpty) {
				itemStack = stack
				return
			}
		}
	}

	override fun hasNext(): Boolean {
		if (!searched) {
			search()
		}

		return itemStack != null
	}

	override fun next(): ItemStack {
		if (!searched) {
			search()
		}

		val itemStack = itemStack ?: throw IllegalStateException("No next element")
		this.itemStack = null
		this.searched = false
		return itemStack
	}
}

class NonEmptyMutableItemStackIterator(override val parent: MutableIterator<ItemStack>) : NonEmptyItemStackIterator(parent), MutableIterator<ItemStack> {
	override fun remove() {
		parent.remove()
	}
}

fun Iterator<ItemStack>.nonEmpty() = NonEmptyItemStackIterator(this)
fun MutableIterator<ItemStack>.nonEmpty() = NonEmptyMutableItemStackIterator(this)